/* ELE 492 HOMEWORK # 5						Date : 30.05.2001

Baris AGLAR			   9720812		 		 b_caglar@hotmail.com
Emre AKIR 		         9623185	          b9623185@hacettepe.edu.tr


Borland C++  4.5
Windows 95
*/
/*
Note :  The bool type  is not defined in our compiler( Borland C++ 4.5 ).
So we have used integer type in equality and relational member functions.
*/

#ifndef RATIONAL_H
#define RATIONAL_H

#include<iostream.h>
#include<iomanip.h>

class Rational{
	friend ostream &operator<<( ostream&, const Rational & );//take input
	friend istream &operator>>( istream&, Rational & );      //print output

public:

	Rational(int = 0, int = 1 );	   	       				  	//constructor
	void setRational(int,int);

	void reduce();                               			  	//reduction
	Rational operator+(  Rational & )const;    				   //addition
	Rational operator-(  Rational & )const;   				   //subtraction
	Rational operator*(  Rational & )const;   				   //multiplication
	Rational operator/(  Rational & )const;    				   //division
	int operator==( Rational & ) const;
	int operator<( Rational & ) const;
	int operator>( Rational & ) const;
	void printFP();                             				   //floating point


private:

	int numerator;
	int denominator;
};

#endif

ostream &operator<<( ostream &output, const Rational &result )
{
	if ( result.denominator==1 )
		output << result.numerator ;
	else
		output << result.numerator << "/" << result.denominator ;
	return output;
}


istream &operator>>( istream &input, Rational &result )
{
	input >> result.numerator;
	input.ignore();
	input >> result.denominator;
	result.setRational(result.numerator , result.denominator);
	return input;
}



Rational :: Rational(int num,int den)
{
setRational(num,den);
}
void Rational :: setRational( int n, int d)
{
	if ( d <= 0)
		{
			cout<< "Denominator cannot be negative or 0 !!!"<<endl;
			denominator = 1;
		}
	else
		denominator = d;

	numerator = n;
	reduce();

}


Rational  Rational :: operator-(  Rational &subtracter )const

{
  Rational result( numerator * subtracter.denominator - denominator * subtracter.numerator, denominator *subtracter.denominator );

	return result;
}

Rational Rational :: operator+( Rational &adder )const
{
	Rational result(numerator * adder.denominator + denominator * adder.numerator,denominator * adder.denominator );

	return result;
}
Rational Rational :: operator*( Rational &multiplier ) const
{
	Rational result( numerator * multiplier.numerator, denominator * multiplier.denominator );

	return result;
}


Rational Rational :: operator/(  Rational &divisor ) const
{

	Rational result (numerator * divisor.denominator, denominator * divisor.numerator);

	return result;
}
int Rational::operator==( Rational &compared ) const
{
	if ( ( numerator == compared.numerator ) && ( denominator == compared.denominator ) )
		return 1;
	else
		return 0;
}

int Rational::operator<( Rational &compared ) const
{
	if ( ( numerator / compared.numerator ) < ( denominator / compared.denominator ) )
		return 1;
	else
		return 0;
}

int Rational::operator>( Rational &compared ) const
{
	if ( ( numerator / compared.numerator ) > ( denominator / compared.denominator ) )
		return 1;
	else
		return 0;
}


void Rational::printFP()
{
	float result = 0;
	result = ( float )numerator / denominator;
	cout << "The rational number in the floating point format is : " << result<<endl;

}



void Rational :: reduce ()
{
	int minimum;
	minimum = ( numerator < denominator ) ? numerator : denominator;
	for ( int i= minimum; i >= 2; i-- )
		if ( ( ( numerator % i) == 0 ) && ( ( denominator % i ) == 0 ) )
		{
			numerator /= i;
			denominator /= i;
		}
}

int main()
{
	Rational a, b(5), c(6,2), d, e;
	e = a + b * c;
	cout << " a="<<a <<" b="<<b <<" c="<<c <<" e="<< e ;
	cout <<"   are rational numbers...\n";
	cout <<"Enter a rational number in the format  a/b,   d=";
	cin  >> d;
	cout << " d=" << d << endl;
	d.printFP();
	cout << ( ( d > c ) ?  "d  is larger than  c " : " c is larger than d "  )<< "\n" << endl;

	return 0;
}



























