#include <iostream.h>


class Rational {
  friend ostream &operator<<(ostream& , const Rational&);
  friend istream &operator>>(istream&, Rational&);

public:
	Rational(int = 0, int = 1);
	Rational operator+(const Rational&) const;
	Rational operator-(const Rational&) const;
	Rational operator*(const Rational&) const;
	Rational operator/(const Rational&) const;
	const Rational &operator=(const Rational&);
	void printFP();
private:
	int numerator;
	int denominator;
	void reduce(Rational &);
};

#include <math.h>
Rational::Rational(int num, int den) {
  numerator=num;
  denominator=den;
}

ostream &operator<<(ostream &output, const Rational &a)
{
 output<<a.numerator<<"\n----\n"<<a.denominator<<endl;
 return output;
}

istream &operator>>(istream &input, Rational &a)
{
 input>>a.numerator>>a.denominator;
 return input;
}
 Rational Rational::operator+(const Rational &rat2) const
{
	Rational temp;
	temp.numerator = numerator * rat2.denominator + rat2.numerator * denominator;
	temp.denominator = denominator * rat2.denominator;
	reduce(temp);
	return temp;
}

Rational Rational::operator-(const Rational &rat2) const
{
  Rational temp;
  temp.numerator = numerator* rat2.denominator - rat2.numerator * denominator;
  temp.denominator = denominator* rat2.denominator;
  reduce(temp);
  return temp;
}

Rational Rational::operator* (const Rational &rat2) const
{
  Rational temp;
  temp.numerator = numerator* rat2.numerator;
  temp.denominator = denominator* rat2.denominator;
  reduce(temp);
  return temp;
}

Rational Rational::operator/ (const Rational &rat2) const
{
  Rational temp;
  temp.numerator = numerator* rat2.denominator;
  temp.denominator = denominator* rat2.numerator;
  reduce(temp);
  return temp;
}

const Rational& Rational::operator=(const Rational &okey)
{
  numerator = okey.numerator;
  denominator = okey.denominator;

  return *this;
}

void Rational::printFP()
  {cout << (float) numerator / denominator << endl;}
void Rational::reduce(Rational &r)
{
  int aDenominator, aNumerator;
  int control = 0, k, common;

  if (r.denominator == 0)
	  cout<<"Division by zero.";

  if (r.denominator < 0) {
	  r.numerator *= -1;
	  r.denominator *= -1;
  }
  aNumerator = abs(r.numerator);
  aDenominator = abs(r.denominator);


  if (aNumerator < aDenominator)
	  common = aNumerator;
  else common = aDenominator;

  for (k = common; k >= 2; k--)  {

	  if ((aNumerator%k == 0) && (aDenominator%k == 0))    {
		  control = 1;
		  common = k;
		  break;
	  }
  }

  if (control == 1)    {
	  r.numerator /= common;
	  r.denominator /= common;
  }

}



int main()
{
  Rational a(12,8), b(5,4), c(6,2), d, e ;
  e=a+b ;
  cout << "a= \n"<< a <<"\n\nb= \n"<< b <<"\n\nc= \n"<< c <<"\n\ne= \n"<< e;
  cin >>d;
  cout << "\n\nd= \n"<<d;
  d.printFP();

  return 0;
}

