#include <iostream.h>
#include "ratio1.h"

RationalNumber::RationalNumber(int n, int d)
{
  numerator = n;
  if (d > 0)
	 denominator = d;
  else
  {  cout << "Denominator must be positive number\nDenominator is initialized to 1" << endl;
	  denominator = 1;
  }
}
RationalNumber RationalNumber::operator+ (RationalNumber &operand2)
{
  return RationalNumber(numerator * operand2.denominator + operand2.numerator * denominator,
								denominator * operand2.denominator);
}

RationalNumber RationalNumber::operator- (RationalNumber &operand2)
{
  return RationalNumber(numerator * operand2.denominator - operand2.numerator * denominator,
								denominator * operand2.denominator);
}

RationalNumber RationalNumber::operator* (RationalNumber &operand2)
{
  return RationalNumber(numerator * operand2.numerator, denominator * operand2.denominator);
}

RationalNumber RationalNumber::operator/ (RationalNumber &operand2)
{
  return RationalNumber(numerator * operand2.denominator, denominator * operand2.numerator);
}

RationalNumber& RationalNumber::operator=(RationalNumber &right)
{
  int i = 2;
  numerator = right.numerator;
  denominator = right.denominator;
  while ((i <= numerator) && (i <= denominator))
  {
    if (((numerator % i) == 0) && ((denominator % i) == 0))
    {
      numerator /= i;
      denominator /= i;
	 }
	 else
		i++;
  }
  return *this;
}

void RationalNumber::print()
{
  if (denominator > 0)
	 cout << numerator << "/" << denominator << endl;
  else if (denominator < 0)
	 cout << -1 * numerator << "/" << -1 * denominator << endl;
  else
	 cout << "Denominator is zero Please check the number again!!!" << endl;
}

void RationalNumber::printInFloatForm()
{
  if (denominator != 0)
	 cout << (float) numerator / denominator << endl;
  else
	 cout << "Denominator is zero Please check the number again!!!" << endl;
}
int RationalNumber::operator> (RationalNumber &number)
{
  double temp1, temp2;

  temp1 = numerator / denominator;
  temp2 = number.numerator / number.denominator;

  if (temp1>temp2)
	  return 1;
  else return 0;
}

int RationalNumber::operator< (RationalNumber &number)
{
  double temp1, temp2;

  temp1 = numerator / denominator;
  temp2 = number.numerator / number.denominator;
  
  if (temp1<temp2)
	  return 1;
  else return 0;
}
int RationalNumber::operator== (RationalNumber &number)
{
  double temp1, temp2;

  temp1 = numerator / denominator;
  temp2 = number.numerator / number.denominator;

  if (temp1 == temp2)
	 return 1;
  else return 0;
}
ostream &operator<<(ostream &output, const RationalNumber &temp)
{
 output << temp.numerator << "/" << temp.denominator << endl;
 return output;
}

istream &operator>>(istream &input, RationalNumber &temp)
{
 cout << " Enter Numerator and Denominator\nAs in format num den " << endl;
 input >> temp.numerator >> temp.denominator;

 return input;
}

int main()
{
  RationalNumber x, y(4, 8), z(30, 66), k;
  cout << "x: ";
  x.print();
  cout << "x: ";
  x.printInFloatForm();
  cout << "y: ";
  y.print();
  cout << "y: ";
  y.printInFloatForm();
  cout << "z: ";
  z.print();
  cout << "z: ";
  z.printInFloatForm();
  cout << endl << endl << "x = x + z" << endl;
  x = x + z;
  cout << "x: ";
  x.print();
  cout << "x: ";
  x.printInFloatForm();
  cout << endl << "x = y + z" << endl;
  x = y + z;
  cout << "x: ";
  x.print();
  cout << "x: ";
  x.printInFloatForm();
  cout << "\nk = x + y * z\nk:";
  k = x + y * z;
  cout << k << endl;
  x = x;
  y = y;
  z = z;
  cout << "check whether x greater than y or not\nprint greater one> "
		 << ( x > y ? x : y) << endl;
  cout << "check whether y smaller than z or not\nprint smaller one> "
		 << ( y < z ? y : z) << endl;
  cout << (x == z ? "x is equal to z" : "x is not equal to z") << endl;
  return 0;
}