//******************************************************
//******************************************************
//***************** HACETTEPE UNIVERSITY ***************
//***************  ELE 492 SPECIAL TOPICS  *************
//******************************************************
//**** HOMEWORK 5 ****************** 
//**********************************
//**** PLATFORM: WINDOWS 98      ***
//**** COMPILER: BORLAND C++ 3.1 ***
//********************************** 
//**** NAME    : ONUR KAPLAN     ***
//**** NUMBER  : 9720917         ***
//**** NAME    : BULENT KARACA   ***
//**** NUMBER  : 9623425         ***
//**********************************
//**********************************

#include <iostream.h>
#include <math.h>

class rational {

    friend ostream &operator<<(ostream &,rational &); 
    friend istream &operator>>(istream &,rational &);

  public:
	rational(int =1,int=1);
   void reduce (int &,int &);
   void printFP();
//----relational operator overloading----------------------
   int operator==(const rational &) const;
   int operator!=(const rational &) const;
   int operator>(const rational &) const;
   int operator<(const rational &) const;
   int operator>=(const rational &) const;
   int operator<=(const rational &) const;
//----arithmetic operator overloading----------------------
    rational operator+(const rational &); 
    rational operator-(const rational &);
    rational operator*(const rational &);
    rational operator/(const rational &);
  private:
   int num;
   int denum;

  }; 

       // ---------- function declerations----------

// ------- initializing part -------

  rational::rational(int a,int b)
    {
     reduce(a,b);
     num=a;
     denum=b;
    }

// ------ reducing part ------

  void rational::reduce (int &x,int &y)
    {
     for (int i=2 ; i<=(fabs(x)) ; i++)
      {
       while ((x%i==0) && (y%i==0))
        { x/=i;
          y/=i;
        }
      }
    }

// ------ display floating point ------

  void rational::printFP()
      {
	cout<<"In floating point  "<<num<<"/"<<denum<<" = "
	    <<(float)num/denum<<'\n';
      }	     

// ------relational operators ------

  int rational::operator==(const rational &right) const
      {
	if (((float)num/denum)==((float)right.num/right.denum))
	     return 1;
	else
	     return 0;
      }
  int rational::operator!=(const rational &right) const
      {
	if ((float)num/denum!=(float)right.num/right.denum)
	     return 1;
	else
	     return 0;
      }	           

  int rational::operator>(const rational &right) const
      {
	if (((float)num/denum)>((float)right.num/right.denum))
	     return 1;
	else
             return 0;
      }
  int rational::operator<(const rational &right) const
      {
	if (((float)num/denum)<(float)right.num/right.denum)
	    return 1;
	else
	    return 0;    	
      }
  int rational::operator>=(const rational &right) const
      {
	if ((float)num/denum>=(float)right.num/right.denum)
	   return 1;
	else
	   return 0;
      }
  int rational::operator<=(const rational &right) const
      {
	if ((float)num/denum<=(float)right.num/right.denum)
	    return 1;
	else
	    return 0;
       }

//------- arithmetic operator overloading -------

  rational rational::operator+(const rational &right)
     {
	rational temp=*this;

	temp=((num*right.denum+(right.num)*denum)/(denum*(right.denum)));
	reduce(temp.num,temp.denum);
	return temp;
      }
  rational rational::operator-(const rational &right)
     {
	rational temp=*this;

	temp=((num*right.denum-(right.num)*denum)/(denum*(right.denum)));
	reduce(temp.num,temp.denum);
	return temp;  
     }
  rational rational::operator*(const rational &right)
     {
	rational temp=*this;

	temp=((num*right.num)/(denum*right.denum));
	reduce(temp.num,temp.denum);
	return temp;
     }
  rational rational::operator/(const rational &right)
     {
	rational temp=*this;

	temp=((num*right.denum)/(denum*right.num));
	reduce(temp.num,temp.denum);
	return temp;
     }
// ------ output operator overloading -------

  ostream &operator<<(ostream &output, rational &arg)
      {
	arg.reduce(arg.num,arg.denum);
	output <<arg.num<<"/"<<arg.denum;
        return output;
      }

// -------------- input (cin) >> operator overloading ---------------

  istream &operator>>(istream &input,rational &arg)
      {
	input >>arg.num;
	input.ignore();
	input >>arg.denum;
        return input;
      }

//------------ main program--------------

main()
{
  rational a,b(5),c(6,2),d,e;

   e=a+b*c;
  cout<<"e=a+b*c"<<'\n';
  cout<<"a= "<<a<<"  b= "<<b<<"  c= "<<c<<"  e= "<<e<<'\n'<<'\n';
  cout<<"enter rational number d: ";
  cin>>d;
  cout<<"d= "<<d<<'\n';
  cout<<"d is ";
  d.printFP(); 
  cout<<"a= "<<a<<" c= "<<c<<'\n';
  cout<< (a==c ? "a and c are equal" : "a and c are not equal")<<'\n';
  cout<<( b>c ? "b is larger than c" : "c is larger than b")<<'\n';

  return 0;
}
