// ELE-492 Homework 5
// Prepared by ZDES LMEZ 
//				and HALUK CANBERI

#include <iostream.h>
#include <iomanip.h>

// class decleration
class Rational
{
	friend ostream &operator<<(ostream&, const Rational&);
	friend istream &operator>>(istream&,Rational&);
	private:
		int numerator;
		int denominator;
	public:
		Rational(int, int);
		void setRational(int &, int &);
		Rational operator +(Rational &);
		Rational operator -(Rational &);
		Rational operator *(Rational &);
		Rational operator /(Rational &);
		int operator ==(Rational &);
		int operator >(Rational &);
		int operator >=(Rational &);
		int operator <(Rational &);
		int operator <=(Rational &);
		int operator !=(Rational &);
		void PrintFP();
		void reduced(int &a, int &b);
};

// constructor of class of Rational
Rational::Rational(int n = 1, int d = 1)
{
	setRational(n, d);
}

// Function to set the rational number
void Rational::setRational(int &a, int &b)
{
	reduced(a,b);
	numerator = a;
	denominator = b;

}


// Function to print the rational number as a float numbet
void Rational::PrintFP()
{
	float a = static_cast<float>(numerator) / denominator;
	cout << a;
}


// Overloaded function for addition
Rational Rational:: operator +(Rational &a)
{
	Rational temp;
	temp.numerator = (numerator * a.denominator) + (denominator * a.numerator);
	temp.denominator = denominator * a.denominator;
	return temp;
}


// Overloaded function for subtraction
Rational Rational:: operator -(Rational &b)
{
	Rational temp;
	temp.numerator = (numerator * b.denominator) - (denominator * b.numerator);
	temp.denominator = denominator * b.denominator;
	return temp;
}


// Overloaded function for multiplication
Rational Rational:: operator *(Rational &c)
{
	Rational temp;
	temp.numerator = numerator * c.numerator;
	temp.denominator = denominator * c.denominator;
	return temp;
}


// Overloaded function for division
Rational Rational:: operator /(Rational &d)
{
	Rational temp;
	temp.numerator = numerator * d.denominator;
	temp.denominator = denominator * d.numerator;
	return temp;
}


// Overloaded function for "=="
int Rational:: operator ==(Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a == b)
		return 1;
	else
		return 0;

}

// Overloaded function for ">"
int Rational:: operator >(Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a > b)
		return 1;
	else
		return 0;

}


// Overloaded function for ">="
int Rational:: operator >=(Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a >= b)
		return 1;
	else
		return 0;

}


// Overloaded function for "<"
int Rational:: operator < (Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a < b)
		return 1;
	else
		return 0;

}


// Overloaded function for "<="
int Rational:: operator <=(Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a <= b)
		return 1;
	else
		return 0;

}


// Overloaded function for "!="
int Rational:: operator !=(Rational &d)
{
	float a, b;
	a = static_cast<float>(numerator) / denominator;
	b = static_cast<float>(d.numerator) / denominator;
	if (a != b)
		return 1;
	else
		return 0;

}


// Funtion to do simplification of rational number
void Rational::reduced(int &a, int &b)
{
	 int n = 2;
	 while ((a >= n) &&(b >= n))
	 {
		if(((a % n) == 0 ) && ((b % n) == 0)){
			a =  a / n;
			b = b / n;
		}
		else{
			n += 1;    }
	 }
}


// Overloaded function  for cout
ostream &operator<<(ostream &output, const Rational &num)
{
	if (num.denominator != 1)
		output << num.numerator << "/" << num.denominator;
	else
		output << num.numerator;
	return output;
}


// Overloaded function for cin
istream &operator>>(istream &input, Rational &num)
{
	input >> num.numerator;
	input.ignore();
	input >> num.denominator;
	num.reduced(num.numerator,num.denominator);
	return input;
}


// Driver program
int main()
{
	Rational a, b(5), c(6,2), d, e;
	e = a + b * c;
	cout << "a="<<a <<" b="<<b <<" c="<<c <<" e="<< e << "\n";
	cout << "Enter a floating number A/B: ";
	cin  >> d;
	cout << "d=" << d << "\n";
	cout << "Floating equivalent of d is: ";
	d.PrintFP();
	cout << "\n" << (b > c ? "b is larger than c ":"c is larger than b");
	cout << "\n" << (b < a ? "b is smaller than a ":"a is smaller than b");
	return 0;
}




