#include <iostream.h>


class Rational {
  friend ostream &operator<<(ostream& , const Rational&);
  friend istream &operator>>(istream&, Rational&);

public:

  Rational(int = 0, int = 1);
  Rational operator+(Rational&);
  Rational operator-(Rational&);
  Rational operator*(Rational&);
  Rational operator/(Rational&);
  Rational &operator=(Rational&);
  int operator>(Rational&);
  int operator<(Rational&);
  int operator==(Rational&);
  void printFP();
  void reduce(Rational &);

private:
  int numerator;
  int denominator;
};

Rational::Rational(int num, int den) {
  numerator=num;
  denominator=den;
}

ostream &operator<<(ostream &output, const Rational &a)
{
 output<<a.numerator<<"/"<<a.denominator<<'\n'<<endl;
 return output;
}

istream &operator>>(istream &input, Rational &a)
{
 cout<<" ENTER NUMERATOR AND DENUMERATOR "<<'\n';
 input>>a.numerator>>a.denominator;

 return input;
}


Rational Rational::operator+ (Rational &rat2)
{
  Rational temp;
  temp.numerator= numerator * rat2.denominator + rat2.numerator * denominator;
  temp.denominator= denominator * rat2.denominator;
  reduce(temp);
  return Rational(temp.numerator,temp.denominator);

}

int Rational::operator> (Rational &rat2)
{
  double num1, num2;

  num1=numerator/denominator;
  num2=rat2.numerator/rat2.denominator;

  if (num1>num2)
	  return 1;
  else return 0;
}

int Rational::operator< (Rational &rat2)
{
  double num1, num2;

  num1=numerator/denominator;
  num2=rat2.numerator/rat2.denominator;

  if (num1<num2)
	  return 1;
  else return 0;
}

int Rational::operator== (Rational &rat2)
{
  double num1, num2;

  num1=numerator/denominator;
  num2=rat2.numerator/rat2.denominator;

  if (num1==num2)
	  return 1;
  else return 0;
}

Rational Rational::operator-(Rational &rat2)
{
  Rational temp;
  temp.numerator= numerator * rat2.denominator - rat2.numerator * denominator;
  temp.denominator= denominator * rat2.denominator;
  reduce(temp);
  return Rational(temp.numerator,temp.denominator);
}

Rational Rational::operator* (Rational &rat2)
{
  Rational temp;
  temp.numerator= numerator * rat2.numerator ;
  temp.denominator= denominator * rat2.denominator;
  reduce(temp);
  return Rational(temp.numerator,temp.denominator);
}

Rational Rational::operator/ (Rational &rat2)
{
  Rational temp;
  temp.numerator= numerator * rat2.denominator ;
  temp.denominator= denominator * rat2.numerator;
  reduce(temp);
  return Rational(temp.numerator,temp.denominator);
}

Rational& Rational::operator=(Rational &okey)
{
  int i = 2;
  numerator = okey.numerator;
  denominator = okey.denominator;
  while ((i <= numerator) && (i <= denominator))
  {
	 if (((numerator % i) == 0) && ((denominator % i) == 0))
	 {
		numerator /= i;
		denominator /= i;
	 }
	 else
		i++;
  }
  return *this;
}

void Rational::reduce(Rational &a)
{
  Rational temp;
  int control = 0, k, common;

  if (a.denominator == 0)
	  cout<<"Division by zero.";

  if (a.denominator < 0){
	  a.numerator *= -1;
	  a.denominator *= -1 ;
	  }

  temp=a;

  if (a.numerator < a.denominator)
	  common = a.numerator;
  else common = a.denominator;

  for (k = common; k >= 2; k--)  {

	  if (((a.numerator%k - a.numerator/k) == 0) && ((a.denominator%k - a.denominator/k)
		  == 0))
		  control = 1;
		  common = k;
		  break;
  }

  if (control == 1)    {
	  temp.numerator /= common;
	  temp.denominator /= common;
  }
 a=temp;
}

void Rational::printFP()
  {cout << (float) numerator / denominator << endl;}


int main()
{
  Rational a, b(5), c(6,2), d, e ;
  e=a+b*c ;
  cout << "a= "<< a <<"\nb= "<< b <<"\nc= "<< c <<"\ne= "<< e;
  cin >>d;
  d.reduce(d);
  cout << "\nd= "<<d;
  d.printFP();
  cout << ( d > c ? "d is larger" : "c is larger")<< endl;
  cout << ( d < a ? "d is smaller" : "a is smaller")<< endl;
  cout << ( d == b ? "d and b are equal" : "not equal")<< endl;

  return 0;
}