//////////////////////////////////////////////////////////////
//															//
//	RATIONAL.H												//
//	The member function declarations of Rational class are	//
//	made in this file.										//
//															//
//////////////////////////////////////////////////////////////
//															//
//	Hakan URHAN												//
//	9721099													//
//	b9721099@hacettepe.edu.tr								//
//	Homework #5												//
//															//
//////////////////////////////////////////////////////////////

#ifndef RATIONAL_H
#define RATIONAL_H

#include <iostream.h>

class Rational {
public:
	// Overloaded friend I/O operators
	friend ostream & operator << ( ostream &, Rational &);
	friend istream & operator >> ( istream &, Rational &);

	// Class constructor, the default values for numerator
	// and denominator is 1
	Rational( int = 1 , int = 1);

	// Overloaded binary operators
	Rational operator +( Rational& ) const;
	Rational operator -( Rational& ) const;
	Rational operator *( Rational& ) const;
	Rational operator /( Rational& ) const;

	// The function that prints the value of rational number in
	// floating point format.
	void printFP();

	// Overloaded relation and equality operators.
	int operator == ( Rational& ) const;
	int operator < ( Rational& ) const;
	int operator > ( Rational& ) const;

	// Class accessors.
	int getNumerator() { return numerator; }
	int getDenominator() { return denominator; }

	// Utility functions.
	void setRational( int, int );
	void reduce();

private:
	int numerator;
	int denominator;
};

#endif