//Turgut Sarikaya 9623626 Section:22  Borland C++ 4.52 Windows NT 
//Homework#:5
//To make a 'Rational Class' that have some properties of rational numbers

#include <iostream.h>

//Class definition
class Rational {
  friend ostream &operator<<(ostream& , const Rational&);
  friend istream &operator>>(istream&, Rational&);

public:

//Prototypes(Member Fuctions)
  Rational(int = 1, int = 1);
  Rational operator+(Rational&);
  Rational operator-(Rational&);
  Rational operator*(Rational&);
  Rational operator/(Rational&);
  Rational &operator=(Rational&);
  int operator>(Rational&);
  int operator<(Rational&);
  int operator==(Rational&);
  void printFP();
  void simplify(Rational &);

private:
//Data members
  int numerator;
  int denominator;
};

//Constructor
Rational::Rational(int newnum, int newden) {
  numerator=newnum;
  denominator=newden;
}

//New output stream operation
ostream &operator<<(ostream &output, const Rational &yazi)
{
 output<<"("<<yazi.numerator<<"/"<<yazi.denominator<<")";
 return output;
}

//New output stream operation
istream &operator>>(istream &input, Rational &a)
{
 cout<<" PLEASE,ENTER NUMERATOR ,AND THAN DENOMINATOR"<<'\n';
 input>>a.numerator;
 cout<<"---"<<endl;
 input>>a.denominator;

 return input;
}


//Overlaoding for operator  +
Rational Rational::operator+ (Rational &operand2)
{
  Rational newnumber;
  newnumber.numerator= numerator * operand2.denominator + operand2.numerator * denominator;
  newnumber.denominator= denominator * operand2.denominator;
  simplify(newnumber);
  return Rational(newnumber.numerator,newnumber.denominator);

}

//Overlaoding for operator  >
int Rational::operator> (Rational &operand2)
{
  double sayi1, sayi2;

  sayi1=numerator/denominator;
  sayi2=operand2.numerator/operand2.denominator;

  if (sayi1 > sayi2)
	  return 1;
  else return 0;
}

//Overlaoding for operator  <
int Rational::operator< (Rational &operand2)
{
  double sayi1, sayi2;

  sayi1=numerator/denominator;
  sayi2=operand2.numerator/operand2.denominator;

  if (sayi1 < sayi2)
	  return 1;
  else return 0;
}

//Overlaoding for operator  ==
int Rational::operator== (Rational &operand2)
{
  double sayi1, sayi2;

  sayi1=numerator/denominator;
  sayi2=operand2.numerator/operand2.denominator;

  if (sayi1 == sayi2)
	  return 1;
  else return 0;
}

//Overlaoding for operator  -
Rational Rational::operator-(Rational &operand2)
{
  Rational newnumber;
  newnumber.numerator= numerator * operand2.denominator - operand2.numerator * denominator;
  newnumber.denominator= denominator * operand2.denominator;
  simplify(newnumber);
  return Rational(newnumber.numerator,newnumber.denominator);
}


//Overlaoding for operator  *
Rational Rational::operator* (Rational &operand2)
{
  Rational newnumber;
  newnumber.numerator= numerator * operand2.numerator ;
  newnumber.denominator= denominator * operand2.denominator;
  simplify(newnumber);
  return Rational(newnumber.numerator,newnumber.denominator);
}

//Overlaoding for operator /
Rational Rational::operator/ (Rational &operand2)
{
  Rational newnumber;
  newnumber.numerator= numerator * operand2.denominator ;
  newnumber.denominator= denominator * operand2.numerator;
  simplify(newnumber);
  return Rational(newnumber.numerator,newnumber.denominator);
}

//Overlaoding for operator =
Rational& Rational::operator=(Rational &equality)
{
  int counter= 2;
  numerator = equality.numerator;
  denominator = equality.denominator;
  while ((counter<= numerator) && (counter<= denominator))
  {
	 if (((numerator % counter) == 0) && ((denominator % counter) == 0))
	 {
		numerator /= counter;
		denominator /= counter;
	 }
	 else
		counter++;
  }
  return *this;
}

//Function to simplify
void Rational::simplify(Rational &zone)
{
  Rational newnumber;
  int permission = 0, k, divide;

  if (zone.denominator == 0)
	  cout<<"Division by zero.";

  if (zone.denominator < 0){
	  zone.numerator *= -1;
	  zone.denominator *= -1 ;
	  }

  newnumber=zone;

  if (zone.numerator < zone.denominator)
	  divide = zone.numerator;
  else divide = zone.denominator;

  for (k = divide; k >= 2; k--)  {

	  if (((zone.numerator%k - zone.numerator/k) == 0) && ((zone.denominator%k - zone.denominator/k)
		  == 0))
		  permission = 1;
		  divide = k;
		  break;
  }

  if (permission == 1)    {
	  newnumber.numerator /= divide;
	  newnumber.denominator /= divide;
  }
 zone=newnumber;
}

//Fuction to print the number in the floating point format
void Rational::printFP()
  {cout << (float) numerator / denominator << endl;}


int main()
{
  Rational a, b(5), c(6,2), d, e ;
  e=a+b*c ;
  cout << "a: "<< a <<"\tb: "<< b <<"\tc: "<< c <<"\te: "<< e << endl;
  cin >>d;
  d.simplify(d);
  cout << "\nd: "<< d <<endl;
  d.printFP();
  cout << "\nComparisons:\n*******************"<<endl;
  cout << ( d > c ? "d is larger than c" : "c is larger than d")<< endl;
  cout << ( d < a ? "d is smaller than a" : "a is smaller than d")<< endl;
  cout << ( d < e ? "d is smaller than e" : "e is smaller than d")<< endl;
  cout << ( d == b ? "d and b are equal" : "not equal")<< endl;

  return 0;
}